package com.jpattern.gwt.client.navigationevent;

import java.util.Map;

import com.jpattern.gwt.client.presenter.IPresenter;

/**
 * 
 * @author Francesco Cina'
 *
 * 12/ago/2011
 */
public abstract class ANavigationEventWrapper implements INavigationEventWrapper {

	private final String name;

	public ANavigationEventWrapper(String name) {
		this.name = name;
	}
	
	@Override
	public final void notifyNavigationEvent(final IPresenter parentPresenter, final Map<String, String> queryStringValues, final String[] childrenEvent, final boolean registerEvent) {
		INavigationEventWrapperCallback callback = new INavigationEventWrapperCallback() {
			@Override
			public void exec(INavigationEvent navigationEvent) {
				navigationEvent.notifyNavigationEvent(parentPresenter, queryStringValues, childrenEvent, registerEvent);
			}
		};
		executeCallback(callback);
	}

//	@Override
//	public final void launchEvent(final HistoryManager historyManager, final IPresenter parentPresenter, final List<IPresenter> createdPresenterList,
//			final String eventName, final String[] tokens, final int i, final Map<String, String> queryStringMap) {
//				INavigationEventWrapperCallback callback = new INavigationEventWrapperCallback() {
//					@Override
//					public void exec(INavigationEvent navigationEvent) {
//						historyManager.lauchEventCallBack(parentPresenter, createdPresenterList, navigationEvent, eventName, tokens, i, queryStringMap);
//					}
//				};
//				executeCallback(callback);
//			}

	protected abstract void executeCallback(INavigationEventWrapperCallback callback);

	@Override
	public String getName() {
		return name;
	}
}